Page MenuHomePhabricator

Make it clear one Reply tool can be open at a time
Closed, InvalidPublic

Description

This task is about helping people understand the following:

  1. Currently [i], one Reply tool can be open at a time on a given page.
    • Said another way: people are only able to draft one comment at a time using the Reply tool on a given page.
  2. To reply to another comment on a given page using the Reply tool, the Reply tool cannot be open anywhere else on the page.

Current situation

In usability testing (T246191), people reported the following issues:

  • It can be difficult to use the Reply tool to respond to a comment while trying to view content elsewhere on the page. In these cases, it's likely you are not able to simultaneously see: i) the comment(s) you are wanting to view to inform the response you are writing and ii) the text input area where you are drafting said response. [ii] [iii]
  • After clicking a "Reply" link, it can be confusing/unexpected/unclear why you are unable to use the Reply tool to respond to a different comment on that same page. [ii] [iii]

Approaches

A living list...

  • Approach 1: All [ reply ] links remain clickable, regardless of whether the Reply tool is open elsewhere on the page.
    • If someone were to click a [ reply ] link (call it, "Reply link 2") after already opening the Reply tool (call it, "Reply tool 1") elsewhere on the page without having already starting a comment, silently discard "Reply tool 1" and open "Reply tool 2."
    • If someone were to click a [ reply ] link (call it, "Reply link 2") after already opening the Reply tool (call it, "Reply tool 1") elsewhere on the page with already having started a comment, show a dialog informing them that should they continue the comment they started drafting in "Reply tool 1" will be discarded.
  • Approach 2: change the [ reply ] link message when the tool is open elsewhere on the page.
    • For this message to be successful, people would need to see it and understand the following (copied from above):
      • One Reply tool can be open at a time on a given page.
      • To reply to another comment on a given page using the Reply tool, the Reply tool cannot be open anywhere else on the page.
    • Note: if this approach were to be taken, we'd need to figure out how to prevent the page from changing shape because of differences in text wrapping.
  • Approach 3: resolve T252558 and allow people to compose multiple comments using the Reply tool in parallel.
    • In this scenario, were someone to draft two comments (Comment 1 and Comment 2) and then post Comment 1, the entire page would be reloaded, Comment 2 would be restored and a hint would be shown informing the user as much.

Open questions

  • What would be involved with implementing T218663 which could resolve the issues in this ticket.
  • What would be involved with implementing T252558 which could resolve the issues in this ticket.
    • The patches to implement the behavior T252558 is asking for have been written. Code review and thorough testing still need to be done. See: T257176#6298110

Done

  • An approach is decided
  • All open questions are resolved

i. This constraint will be removed once T218663 is implemented
ii. @TheDJ: https://w.wiki/SYs
iiii. @Dvorapa: https://w.wiki/SYt

Event Timeline

ppelberg renamed this task from Make it clear one to Make it clear one Reply tool can be open at a time.Jul 6 2020, 4:35 AM
ppelberg created this task.
ppelberg updated the task description. (Show Details)

Note that once T252558 is resolved, most of the issues that prevent us from having more that one reply widget open go away.

ppelberg updated the task description. (Show Details)Jul 6 2020, 11:19 PM

Note that once T252558 is resolved, most of the issues that prevent us from having more that one reply widget open go away.

@Esanders and I are going to discuss the feasibility of resolving T252558; we'll report back following that conversation.

In the meantime, I've added two approaches to the task description's "Approaches" section that came up in the conversation Ed, Jess and I had this morning:

  • Approach #2: change the [ reply ] link message when the tool is open elsewhere on the page.
  • Approach 3: resolve T252558 and allow people to compose multiple comments using the Reply tool in parallel.
ppelberg updated the task description. (Show Details)Jul 6 2020, 11:23 PM

@Esanders what is this ticket's relationship to T218663?

I'd assumed this ticket (T257176) depended on that one (T218663), although the conversation we had this morning is leading me to wonder whether that's actually the case...

No dependency on T218663, we only need sessionStorage. "Upgrading" to localStorage just makes your draft replies persist across tabs, but as the post-publish reload will always happen within a single tab, it doesn't affect this use case. Flow already uses sessionStorage auto-save to do the same thing.

No dependency on T218663, we only need sessionStorage. "Upgrading" to localStorage just makes your draft replies persist across tabs, but as the post-publish reload will always happen within a single tab, it doesn't affect this use case. Flow already uses sessionStorage auto-save to do the same thing.

Excellent. Okay. Understood. Updating the "Open questions" in the task description with this information.

ppelberg updated the task description. (Show Details)Jul 7 2020, 3:42 PM

Notes from the conversation @Esanders and I had on 7-July

  • What would be involved with implementing T252558 which could resolve the issues in this ticket.

To do what T252558 is asking for, the following needs to happen:

  • The patches Ed has written so far need to be reviewed (in progress)
  • Once reviewed, the Reply tool will need to be thoroughly tested (timing is TBD)

As part of the same conversation Ed and I had, we decided it was worthwhile to prioritize work on T252558.

Before I de-prioritize this task, Ed can you please clarify what issues, beyond those which T252558 will resolve, will need to be addressed before people will be able to have more than on Reply tool open on a given page?

The question above stems from the bolded bit here:

Note that once T252558 is resolved, most of the issues that prevent us from having more that one reply widget open go away.

ppelberg updated the task description. (Show Details)Jul 11 2020, 12:10 AM
JTannerWMF renamed this task from Make it clear one Reply tool can be open at a time to Enable more than one Reply tool open at a time.Jul 22 2020, 5:53 PM
JTannerWMF renamed this task from Enable more than one Reply tool open at a time to Make it clear one Reply tool can be open at a time.
JTannerWMF added a subscriber: JTannerWMF.

This task will become invalid after T257305 is completed

ppelberg closed this task as Invalid.Jul 23 2020, 2:11 AM

This task will become invalid after T257305 is completed

Per the above, I'm closing this task as invalid.